#include "testlib.h"
#include <vector>
#include <unistd.h>

using namespace std;

struct Node {
    int type;
    int t0;
    int t1;
    int t2;
    int t3;
    int v;
    vector<int> expr;
};

vector<int> tunnels;
vector<bool> used;
vector<Node> nodes;

vector<int> vars;

int calc(const vector<int>& expr) {
    vector<int> st;
    for (auto el : expr) {
	 if (el >= 0) {
	     st.push_back(vars[el]);
	 } else {
             int v2 = st.back(); st.pop_back();
	     int v1 = st.back(); st.pop_back();
	     if (el == -1) {
		     st.push_back(v1+v2);
	     } else if (el == -2) {
		     st.push_back(v1-v2);
	     } else {
		     st.push_back(v1*v2);
	     }
	 }
    }
    return st.back();
}

void go(int t, int E) {
   int cnt = 0;
   while (cnt < 1000) {
       used[t] = true;
       fprintf(stderr, "t %d\n", t);
       if (t >= 1 && t <= E) {
            return;
       }
       Node node = nodes[tunnels[t]];

       int val = calc(node.expr);

       if (node.type == 0) {
	   vars[node.v] = val;
	   t = node.t1;
       } else {
           if (val > 0) {
	      t = node.t1;
	   } else if (val < 0) {
	      t = node.t2;
	   } else {
	      t = node.t3;
	   }
       }

       ++cnt;
   }
}

int main(int argc, char *argv[]) {
    registerTestlibCmd(argc, argv);
    int N = inf.readInt(0, 99);
    int M = inf.readInt(0, 99);
    int T = inf.readInt(1, 500);
    int E = inf.readInt(1, T - 1);
    int V = inf.readInt(1, 9);

    used.resize(T);
    tunnels.resize(T);
    vars.resize(V);
    for (int i = 0; i < N; ++i) {
        // first cave
        int t0 = inf.readInt(0, T);
        int t1 = inf.readInt(0, T);
        int v = inf.readInt(0, V - 1);
        int n = inf.readInt(1, 10);
        vector<int> expr;
        for (int j = 0; j < n; ++j) {
            int e = inf.readInt(-3, V - 1);
            expr.push_back(e);
        }
	nodes.emplace_back(Node{0, t0, t1, -1, -1, v, expr});
	tunnels[t0] = nodes.size() - 1; 
    }

    for (int i = 0; i < M; ++i) {
        // second cave
        int t1 = inf.readInt(0, T);
        int t2 = inf.readInt(0, T);
        int t3 = inf.readInt(0, T);
        int t4 = inf.readInt(0, T);
	int n = inf.readInt(1, 10);
        vector<int> expr;
        for (int j = 0; j < n; ++j) {
            int e = inf.readInt(-3, V - 1);
            expr.push_back(e);
        }
	nodes.emplace_back(Node{1, t1, t2, t3, t4, -1, expr});
	tunnels[t1] = nodes.size() - 1;
    }

    int K = ouf.readInt();
    if (K > T) {
	    quit(_pe, "Too many cases");
    }
    fprintf(stderr, "K %d\n", K);
    for (int i = 0; i < K; ++i) {
        for (int j = 0; j < V; ++j) {
	    vars[j] = ouf.readInt();
	    if (vars[j] > 1000 || vars[j] < -1000) {
		    quit(_pe, "Bad variable");
	    }
	    fprintf(stderr, "%d ", vars[j]);
	}
	fprintf(stderr, "\n");
	go(0, E);
    }

    int cnt = 0;
    for (int i = 0; i < T; ++i) {
	if (used[i]) {
	    ++cnt;
	}
    }

    int best_cnt = ans.readInt(0, T);
    int score = ans.readInt();
    if (best_cnt <= cnt) {
    	quitf(_ok, "cnt %d", cnt); 
    } else {
	printf("%d", score * (cnt + 1) / best_cnt);
	fflush(stdout);
	_exit(1);
    }
}
